app.controller('ApostaCtrl', [
	'$scope', 
	'$ionicModal',
	'$http', 
	'$localstorage', 
	'$ionicPopup',
	'SERVIDOR',
	'$ionicLoading',
	'moment',
	// 'Socket',
	'$cordovaSocialSharing',
	'$ionicActionSheet',
	'$timeout',
	'$ionicSlideBoxDelegate',
		function (
			$scope,
			$ionicModal,
			$http, 
			$localstorage,
			$ionicPopup,
			SERVIDOR,
			$ionicLoading,
			moment,
			// Socket,
			$cordovaSocialSharing,
			$ionicActionSheet,
			$timeout,
			$ionicSlideBoxDelegate
		) {
	$scope.num_apostas      = 0;
	$scope.usersConectatos 	= 0;
	$scope.aposta 			= {};
	$scope.minhasapostas 	= [];
	$scope.minhasvitorias 	= [];
	$scope.result 			= false;
	$scope.loteria 			= false;
	$scope.loterias 		= [];

	$scope.totalBets 		= 0;
	$scope.seusBets  		= 0;
	$scope.selecao 			= [];

	$scope.data = {};

	$scope.logado = $localstorage.get('logado') || false; 

	$scope.showShare = function(loteria) {
		window.plugins.socialsharing.share(loteria.descricao, 'BetPlay', loteria.midia, 'https://play.google.com/store/apps/details?id=br.com.satecnologia.betplay')
	};



 // Socket.on('connection', function () {
 //    console.log('conectado');
 //  });
 // Socket.on('usuariosConectados', function (data) {
 	
 // 	 $scope.$apply(function () {
 //            $scope.usersConectatos = data
 //        });

 // 	 console.log(data);

 //  });


	$scope.alerta = function(titulo,msg){
		$ionicPopup.alert({
			title: titulo,
			template: msg
		});	
	}
	$scope.showLoad = function(msg){
		$ionicLoading.show({
			template: msg
		});
	}

	$scope.hideLoad = function(){
		$ionicLoading.hide();
	}
		
	$scope.loteriaAtiva = function(){
		$scope.showLoad('Buscando BeyPlay do dia...');
		$http.get(SERVIDOR.BASE+'/loteria')
		.then(function(data){
			$scope.hideLoad();

			if(data.data) {
				$scope.result = true;
				$scope.loterias = data.data;
				$ionicSlideBoxDelegate.slide(0);
				$ionicSlideBoxDelegate.update();

				//$scope.alerta('BetPlay: '+ $scope.loteria.titulo,'<img class="full-image text-center" ng-src="'+$scope.loteria.midia+'" /> \n Aproveite o periodo de testes, e tenha mais chances de ganhar o premio maximo!! <br/> Numero do sorteio de hoje: '+ $scope.loteria._id +' \n Validade: '+ moment($scope.loteria.validate).fromNow() +'');	
			} else {
				$scope.result = false;
				$scope.alerta('Nenhum BetPlay ativo!', 'No momento não temos nenhum betplay ativo, aguarde um novo BetPlay ser cadastrado!');
			}
			
			
		}, function(data){
			$scope.hideLoad();
			if(data.status == 401) {
				$scope.alerta('Você não tem permissão para essa ação, verifique se você está logado corretamente.');
			}
		})
	}



  $scope.user = false;
  $scope.loginData = {};
  $scope.cadData = {};
  $scope.modal= {};


  $scope.b64EncodeUnicode = function (str) {
      return btoa(str);
  }

  $scope.user = function(){
  	$scope.showLoad('Buscando seus dados...');
    $http.get(SERVIDOR.BASE + '/user/me', { 
        headers: { 
            "Authorization": "Basic "+$scope.b64EncodeUnicode($scope.loginData.email+':'+$scope.loginData.password)
        }
    })
      .then(function(data){
      	$scope.hideLoad();
      },function(data){
      		$scope.hideLoad();
			if(data.status == 401) {
				$scope.alerta('Você não tem permissão para essa ação, verifique se você está logado corretamente.');
			}
      });
  };

  // Create the login modal that we will use later
  $ionicModal.fromTemplateUrl('./templates/login.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  // Triggered in the login modal to close it
  $scope.closeLogin = function() {
    $scope.modal.hide();
  };

  // Open the login modal
  $scope.login = function() {
    $scope.modal.show();
  };

 
  // Perform the login action when the user submits the login form
  $scope.doLogin = function() {
  	$scope.showLoad('Fazendo login...');
    $http.post(SERVIDOR.BASE + '/login',{},{ 
        headers: { 
            "Authorization": "Basic "+$scope.b64EncodeUnicode($scope.loginData.email+':'+$scope.loginData.password)
        }
    })
    .then(function(data){
    	$scope.hideLoad();

      $localstorage.set('login', $scope.loginData.email);
      $localstorage.set('password', $scope.loginData.password);
      $localstorage.set('logado', true);
      $scope.logado = $localstorage.get('logado');
      $localstorage.setObject('user', data.data);
      $scope.closeLogin();
    },function(data){
    	$scope.hideLoad();
		if(data.status == 401) {
			$scope.alerta('Você não tem permissão para essa ação, verifique se você está logado corretamente.');
		}
    })

  };


  $scope.addLogin = function() {
  	$scope.showLoad('Cadastrando novo usuário...');
    $http.post(SERVIDOR.BASE + '/users',
      {
        email: $scope.cadData.email,
        password: $scope.cadData.password
      }
    )
    .then(function(data){
    	$scope.hideLoad();
		$scope.alerta('Cadastro realizado!!!','Cadastro realizado, agora faça o seu login e aposte ilimitado até ganhar o grande prêmio!');	
        $scope.cadData = {};
    },function(data){
    	$scope.hideLoad();
		if(data.status == 401) {
			$scope.alerta('Você não tem permissão para essa ação, verifique se você está logado corretamente.');
		}
    });

  };


 	
	$scope.apostar = function(numeros, index, _id){
		$scope.num_apostas = $scope.num_apostas + 1;
		$scope.showLoad('Validando sua aposta.. Aguarde..');
		
		if($localstorage.get('logado')) {
			$http.post(SERVIDOR.BASE+'/apostar/'+ _id,
				{
					numeros: $scope.data.numeros[index]
				},
				{ 
					headers: { 
						"Authorization": "Basic "+$scope.b64EncodeUnicode($localstorage.get('login')+':'+$localstorage.get('password'))
					}
				}
			)
			.then(function(data){
				//console.log(data.data);
				$scope.hideLoad();

				if(data.data.acerto) {
					$scope.alerta('Acertô mizeraví!!',data.data.msg);			
				} else {
					$scope.alerta('Não foi desta vez!',data.data.msg);						
				}

				if($scope.num_apostas == 5 ) {
					AdMob.showInterstitial();
					$scope.num_apostas = 0;
					//console.log('show aposta');
				}
				$scope.aposta = {};
			}, function(response) {
					$scope.hideLoad();
					if(data.status == 401) {
						$scope.alerta('Você não tem permissão para essa ação, verifique se você está logado corretamente.');
					}
			});
		} else {
			$scope.hideLoad();
			$scope.alert('Faça primeiro o seu login!', 'Você não deve está logado corretamente, verifique seu login e tente novamente, caso continue com erro, procure algum administrador.');
		}
		$scope.data.numeros = {};
	};

	$scope.minhasApostas = function(){
		if($localstorage.get('logado')) {
			$http.get(SERVIDOR.BASE+'/apostas/'+$localstorage.getObject('user')._id,
				{ 
			        headers: { 
			            "Authorization": "Basic "+$scope.b64EncodeUnicode($localstorage.get('login')+':'+$localstorage.get('password'))
			        }
			    }
	        )
	        .then(function(data){
	        	//console.log(data.data);
	        	$scope.minhasapostas = data.data;
			})
		} else {
			alert('Faça o login');
		}
	}

	$scope.minhasVitorias = function(){
		if($localstorage.get('logado')) {
			$http.get(SERVIDOR.BASE+'/apostas/'+$localstorage.getObject('user')._id+'/vitorias',
				{ 
			        headers: { 
			            "Authorization": "Basic "+$scope.b64EncodeUnicode($localstorage.get('login')+':'+$localstorage.get('password'))
			        }
			    }
	        )
	        .then(function(data){
	        	//console.log(data.data);
	        	$scope.minhasvitorias = data.data;
			})
		} else {
			alert('Faça o login');
		}
	}


}])