var online = true;

var app = angular.module('loteria', [
    'ionic', 
    'starter.controllers',
    'ionic.utils',
    'angularMoment',
    // 'socketService',
    'ngCordova'
  ])

.constant('SERVIDOR', 
  { 
    SOCKET: online ? 'https://api.betplay.com.br'      : 'http://localhost:3000',
    BASE:   online ? 'https://api.betplay.com.br/api'  : 'http://localhost:3000/api'
  }
)
.run(['$ionicPlatform', function($ionicPlatform) {

  $ionicPlatform.ready(function() {
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      StatusBar.styleDefault();
    }

    ionic.Platform.isFullScreen = true;


    /*

    var androidConfig = {
      "senderID": "594689465617",
    };

    //token: "AIzaSyDTZat60JJVbu39kXdQkbm8IH4TMoiy2bc"
  
    //if(!registrado){
      $cordovaPush.register(androidConfig).then(function(result) {
        // Success
      }, function(err) {
        // Error
      })
    //};

  
      

    $rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
      switch(notification.event) {
        case 'registered':
          if (notification.regid.length > 0 ) {
            alert('registration ID = ' + notification.regid);
          }
          break;

        case 'message':
          // this is the actual push notification. its format depends on the data model from the push server
          alert('message = ' + notification.message + ' msgCount = ' + notification.msgcnt);
          break;

        case 'error':
          alert('GCM error = ' + notification.msg);
          break;

        default:
          alert('An unknown GCM event has occurred');
          break;
      }
    });


      // WARNING: dangerous to unregister (results in loss of tokenID)
      $cordovaPush.unregister(options).then(function(result) {
        // Success!
      }, function(err) {
        // Error
      })


  */

});

   
}])




.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

  .state('app.apostar', {
    url: '/apostar',
    views: {
      'menuContent': {
        templateUrl: 'templates/apostas/apostar.html',
          controller: 'ApostaCtrl'
      }
    }
  })

  .state('app.minhasapostas', {
    url: '/minhasapostas',
    views: {
      'menuContent': {
        templateUrl: 'templates/apostas/minhasapostas.html',
          controller: 'ApostaCtrl'
      }
    }
  })
  .state('app.minhasvitorias', {
    url: '/minhasvitorias',
    views: {
      'menuContent': {
        templateUrl: 'templates/apostas/minhasvitorias.html',
          controller: 'ApostaCtrl'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/apostar');
});

angular.module('ionic.utils', [])

.factory('$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    }
  }
}]).filter('range', function() {
  return function(input, total) {
    total = parseInt(total);

    for (var i=0; i<total; i++) {
      input.push(i);
    }

    return input;
  };
});

// angular.module('socketService', ['btford.socket-io'])

// .factory('Socket', [
//   'socketFactory',
//   'SERVIDOR',
//   function (socketFactory,SERVIDOR) {
//     var myIoSocket = io.connect(SERVIDOR.SOCKET);

//     mySocket = socketFactory({
//       ioSocket: myIoSocket
//     });
//     return mySocket;
// }]);
